                   //  Управление  двумя шаговыми двигателями с плавным ускорением и замедлением


#include <MicroView.h>  // библиотека для работы с платформой MicroView
#include <Wire.h>       // библиотека для работы I²C 
#include "TroykaRTC.h"  // библиотека для работы с часами реального времени
    // EEPROM — энергонезависимая память
#include <EEPROM.h>  // библиотека для записи и считывания информации с EEPROM
   //все библиотеки взял с сайта Амперка(Спасибо им) и поместил в папку libraries в программе Arduini IDE.
   
#define LEN_TIME 12  // размер массива для времени с учётом завершающего нуля
#define LEN_DATE 12  // размер массива для даты с учётом завершающего нуля
#define LEN_DOW 12  // размер массива для дня недели с учётом завершающего нуля
RTC clock;          // создаём объект для работы с часами реального времени

    // драйверы Troyka-Stepper для шаговиков подключены через плату расширения(Troyka Shield) к следующим пинам:
  const byte stepPin = 3;        //  сделать шаг
  const byte directionPin = 5;   //  направление
  const byte enablePin = 6;      //  питание
  const byte stepPin2 = 0;       //  сделать шаг
  const byte directionPin2 = 1;  //  направление
  const byte enablePin2 = 2;     //  питание
      // задаём переменные:
  long shagov = 0;   // количество шагов
  int times = 0;     // задержка шага
  long q = 0;        // сколько шагов сделано ось RA
  long w = 0;        // сколько шагов сделано ось DEC
  long d = 0;        // сколько должно быть шагов дв1
  long d2 = 0;       // сколько должно быть шагов дв2
  int h = 0;         // координаты RA, часы
  int m = 0;         // координаты RA, минуты
  int dec = 0;       // координаты DEC,градусы
  int dec2 = 0;      // координаты DEC, минуты
  long q1 = 0;       // количество минут, на которое надо повернуть ось RA
  long w1 = 0;       // количество минут, на которое надо повернуть ось DEC
  int tr = 0;
  unsigned long currentTime;
  unsigned long loopTime;
  unsigned long currentTime1;
  unsigned long loopTime1;
  
  void setup() {

    // Настраиваем нужные контакты на выход
  pinMode(stepPin, OUTPUT);      // этот пин даёт команду сделать шаг двигателю1
  pinMode(directionPin, OUTPUT); // этот пин даёт команду выбрать направление вращения двигателя1
  pinMode(enablePin, OUTPUT);    // этот пин управляет питанием двигателя1
  pinMode(stepPin2, OUTPUT);        //   шаг   двиг2
  pinMode(directionPin2, OUTPUT);   //   направление  вращения  двиг2
  pinMode(enablePin2, OUTPUT);      //   питание      двиг2

  uView.begin();  // начало работы с MicroView
  //ниже для дисплея
   uView.clear(PAGE);      // очищаем экран
  uView.setFontType(0);   //шрифт
  uView.setCursor(0, 0);  // перемещаем курсор
   uView.print("RA"); // печатаем строку
  uView.display();  // отображаем содержимое из буфера экрана
 uView.setCursor(0,18);
   uView.print("DE");  
     uView.display();  // отображаем содержимое из буфера экрана
//выше для дисплея
  clock.begin();
  // метод установки времени и даты в модуль вручную
  // clock.set(10,25,45,27,07,2005,THURSDAY);
  // метод установки времени и даты автоматически при компиляции
  clock.set(__TIMESTAMP__);

  currentTime = millis();       // считываем время, прошедшее с момента запуска программы
  loopTime = currentTime; 
  currentTime1 = millis();
  loopTime1 = currentTime1; 
     }



         // далее идёт цикл программы

  void loop() {

  float voltage = analogRead(A0) / 1024.0;   // высчитываем напряжение с кнопок
/*    lcd.setCursor(0, 1);  // ставим курсор дисплея на 0 столбец, 1 строка
  lcd.print(voltage, 2);  // печатаем напряжение идущее с кнопок 
      uView.setFontType(0);   //шрифт
  uView.setCursor(16, 8);  // перемещаем курсор
   uView.print(voltage); // печатаем строку
  uView.display();  // отображаем содержимое из буфера экрана   */

                                                             
         // обучаем контроллер понимать клики кнопок
// каждая из кнопок при нажатии подаёт напряжение на пин A0 через отдельный резистор 
//напряжение зависит от номинала резисторов
  bool clic1 = (voltage > 0.64 && voltage < 0.68);  // если напряжение находится в пределах от 0.90 до 0.92
  bool clic2 = (voltage > 0.98 && voltage < 1.02);   // аналогично
  bool clic3 = (voltage > 0.69 && voltage < 0.73);   // аналогично
  bool clic4 = (voltage > 0.89 && voltage < 0.93);    // аналогично
  bool clic5 = (voltage > 0.75 && voltage < 0.79);   // аналогично
  bool clic6 = (voltage > 0.81 && voltage < 0.85);
  bool neclic = (voltage < 0.05);
  // если кнопки отпущены - работает стягивающий резистор и на пине "A0" ноль вольт
  // в таком варианте одновременно несколько кнопок работать не могут 

  char time[LEN_TIME]={0};  // массив для хранения текущего времени
  char date[LEN_DATE]={0};  // массив для хранения текущей даты
  char dow[LEN_DOW]={0};   // массив для хранения текущего дня недели
  clock.read();            // запрашиваем данные с часов
  clock.getTimeStr(time, LEN_TIME);  // сохраняем текущее время в массив time
  clock.getDateStr(date, LEN_DATE);  // сохраняем текущую дату в массив date
  clock.getDOWStr(dow, LEN_DOW);    // сохраняем текущий день недели в массив dow
  
          // если кнопка только что отпущена,замедляем и останавливаем первый или второй двигатель
      if(neclic && tr == 0) {  
  digitalWrite(enablePin, LOW);    // выключаем двигатель 1     
  digitalWrite(stepPin, LOW);      // не делаем шаг
  digitalWrite(stepPin2, LOW);     // не подаём питание на след. обмотку дв2
  digitalWrite(enablePin2, LOW);   // выключаем двигатель 2  

  uView.setFontType(0);   //шрифт
  uView.setCursor(16, 0);  // перемещаем курсор
   uView.print(h); // печатаем строку
  uView.display();  // отображаем содержимое из буфера экрана
   uView.setFontType(0);   //шрифт
  uView.setCursor(38, 0);  // перемещаем курсор
   uView.print(m); // печатаем строку
  uView.display();  // отображаем содержимое из буфера экрана
  uView.setFontType(0);   //шрифт
  uView.setCursor(16, 18);  // перемещаем курсор
   uView.print(dec); // печатаем строку
  uView.display();  // отображаем содержимое из буфера экрана
    uView.setFontType(0);   //шрифт
  uView.setCursor(38, 18);  // перемещаем курсор
   uView.print(dec2); // печатаем строку
  uView.display();  // отображаем содержимое из буфера экрана
        uView.setFontType(0);   //шрифт
  uView.setCursor(0, 40);  // перемещаем курсор
   uView.print(time); // печатаем строку
  uView.display();  // отображаем содержимое из буфера экрана
     }  
              // если кнопка 1 нажата, прибавляем часы (ось RA)
 
      if(clic1) {                  // если клик кнопка 1
  h = h + 1 ;                      // при нажатии кнопки прибавляем час
  if(h >= 24) h = 0;               // если 24 часа, обнуляем
  delay(130);                      // ждём
  uView.setFontType(0);   //шрифт
  uView.setCursor(16, 0);  // перемещаем курсор
   uView.print("  "); // печатаем строку
  uView.display();  // отображаем содержимое из буфера экрана
    uView.setFontType(0);   //шрифт
  uView.setCursor(16, 0);  // перемещаем курсор
   uView.print(h); // печатаем строку
  uView.display();  // отображаем содержимое из буфера экрана
     }

               // если кнопка 2 нажата, прибавляем минуты (ось RA)

       if(clic2) {
  m = m + 1;                            // при нажатии кнопки прибавляется 1 минута (ось RA)
 /* if(m >= 60) { m = 0 ; h = h + 1;  }   // если минут больше 60,обнуляем минуты прибавляем час*/
    if(m >= 60)  m = 0 ;
  delay(130);                           // пауза
  if(h >= 24) h = 0;                    // если часов 24, обнуляем часы
   uView.setFontType(0);                //шрифт
  uView.setCursor(38, 0);             // перемещаем курсор
   uView.print("  ");                 // печатаем строку
  uView.display();                    // отображаем содержимое из буфера экрана
     uView.setFontType(0);             //шрифт
  uView.setCursor(38, 0);             // перемещаем курсор
   uView.print(m);                    // печатаем строку
  uView.display();                // отображаем содержимое из буфера экрана
     }
                // если кнопка 3 нажата, прибавляем градусы (ось DEC)
       if(clic3) {                      // если клик  кнопка3
  dec = dec + 1;                        // прибавляем один градус (ось DEC )
  if (dec >= 90) dec = -30;               // если градус больше 90, обнуляем
  delay(130);                           // ждем
  uView.setFontType(0);   //шрифт
  uView.setCursor(16, 18);  // перемещаем курсор
   uView.print("   "); // печатаем строку
  uView.display();  // отображаем содержимое из буфера экрана
    uView.setFontType(0);   //шрифт
  uView.setCursor(16, 18);  // перемещаем курсор
   uView.print(dec); // печатаем строку
  uView.display();  // отображаем содержимое из буфера экрана
     } 
                // если кнопка 4 нажата,прибавляем минуты в градусах
       if(clic4) {                      // клик 4 кнопка
  dec2 = dec2 + 1;                      // прибавляем минуты (ось DEC)
 /* if (dec2 >= 60) { dec2 = 0; dec = dec + 1; }  // если минут стало 60,обнуляем минуты и добавляем к градусу 1*/
    if (dec2 >= 60)  dec2 = 0;

  delay(130);                           // пауза против дребезга
    uView.setFontType(0);   //шрифт
  uView.setCursor(38, 18);  // перемещаем курсор
   uView.print("  "); // печатаем строку
  uView.display();  // отображаем содержимое из буфера экрана
      uView.setFontType(0);   //шрифт
  uView.setCursor(38, 18);  // перемещаем курсор
   uView.print(dec2); // печатаем строку
  uView.display();  // отображаем содержимое из буфера экрана
     }
                      
                // если клик 5 000000000000000000000000000000000000000000000000000000000000000000000000000

       if(clic5 && d > q) {              // если клик кнопки5, и заданное кол-во шагов больше сделанного, то:
  times = 20;                            // задержка шага в начале
  shagov = d - q;                        // из заданного кол-ва шагов вычитаем сделанное кол-во шагов
    for( long i = 0; i < shagov; ++i) {   // счетчик шагов
  digitalWrite(enablePin, HIGH);         // Подаём питание на двигатель
  digitalWrite(directionPin, HIGH);      // Задаём направление вращения вправо
  digitalWrite(stepPin, HIGH);           // подаётся питпние на след обмотку
  delay(times);                           // ждём
                    // для ускорения
   if(shagov <= 300) times = 20;
   else {
    currentTime1 = millis();
  if(currentTime1 >= (loopTime1 + 30)&& i > 0 && i < 100){
    times = times - 1;
    if(times <= 1)times = 1;
        loopTime1 = currentTime1;
    }
        currentTime1 = millis();            // записываем время с момента старта программы
   if(currentTime1 >= (loopTime1 + 30)&& i >=(shagov - 100)){
    times = times + 1;
    if(times >= 20) times = 20;           // ограничиваем продолжительность паузы
            loopTime1 = currentTime1;
    }}
  digitalWrite(stepPin, LOW);            // не подаём питание на след обмотку
  q = q + 1;                             // записываем сделанный шаг
    }
        uView.setFontType(0);   //шрифт
  uView.setCursor(16, 8);  // перемещаем курсор
   uView.print("      "); // печатаем строку
  uView.display();  // отображаем содержимое из буфера экрана 
    uView.setFontType(0);   //шрифт
  uView.setCursor(16, 8);  // перемещаем курсор
   uView.print(q); // печатаем строку
  uView.display();  // отображаем содержимое из буфера экрана
    uView.setCursor(16, 26);  // перемещаем курсор
   uView.print("      "); // печатаем строку
  uView.display();  // отображаем содержимое из буфера экрана 
      uView.setFontType(0);   //шрифт
  uView.setCursor(16, 26);  // перемещаем курсор
   uView.print(w); // печатаем строку
  uView.display();  // отображаем содержимое из буфера экрана
  }   
       
       if(clic5 && d < q) {              // если мы возвращаемся на некоторое кол-во шагов назад, то:
  times = 20;                            // задержка шага в начале
  shagov = q - d;                        // вычитаем из сделанного кол-ва шагов нужное кол-во шагов
    for( long i = 0; i < shagov; ++i) {
  digitalWrite(enablePin, HIGH);         // Подаём питание на двигатель
  digitalWrite(directionPin, LOW);       // Задаём направление вращения вправо
  digitalWrite(stepPin, HIGH);           // подаётся питпние на след обмотку
  delay(times);                          // ждём
  
                 // для ускорения
    if(shagov <= 300) times = 20;    //если нужно крутить движки не далеко,ограничиваем скорость вращения
   else {                           // иначе делаем то что в  фг скобках и разгоняем движок
     currentTime1 = millis();
  if(currentTime1 >= (loopTime1 + 30)&& i > 0 && i < 100){
    times = times - 1;
    if(times <= 1)times = 1;
        loopTime1 = currentTime1;
    }
        currentTime1 = millis();
   if(currentTime1 >= (loopTime1 + 30)&& i >=(shagov - 100)){
    times = times + 1;
    if(times >= 20) times = 20;
            loopTime1 = currentTime1;
    }}
  digitalWrite(stepPin, LOW);            // не подаём питание на след обмотку
  q = q - 1;                             // вычитаем один шаг
     }
         uView.setFontType(0);   //шрифт
  uView.setCursor(16, 8);  // перемещаем курсор
   uView.print("      "); // печатаем строку
  uView.display();  // отображаем содержимое из буфера экрана 
    uView.setFontType(0);   //шрифт
  uView.setCursor(16, 8);  // перемещаем курсор
   uView.print(q); // печатаем строку
  uView.display();  // отображаем содержимое из буфера экрана
    uView.setCursor(16, 26);  // перемещаем курсор
   uView.print("      "); // печатаем строку
  uView.display();  // отображаем содержимое из буфера экрана 
      uView.setFontType(0);   //шрифт
  uView.setCursor(16, 26);  // перемещаем курсор
   uView.print(w); // печатаем строку
  uView.display();  // отображаем содержимое из буфера экрана
  }   
        if(clic5 && d2 > w) {            // если шагаем на некоторое кол-во шагов вперед, то:
          times = 20;                    // задержка шага в начале
  shagov = d2 - w;                       // вычитаем из нужного кол-ва шагов сделанное кол-во шагов
    for( long i = 0; i < shagov; ++i) {
  digitalWrite(enablePin2, HIGH);        // Подаём питание на двигатель
  digitalWrite(directionPin2, HIGH);     // Задаём направление вращения вправо
  digitalWrite(stepPin2, HIGH);          // подаётся питпние на след обмотку
  delay(times);                          // ждём
  
               // для ускорения
     if(shagov <= 300) times = 20;
   else {
    currentTime1 = millis();
  if(currentTime1 >= (loopTime1 + 30)&& i > 0 && i < 100){
    times = times - 1;
    if(times <= 1)times = 1;
        loopTime1 = currentTime1;
    }
        currentTime1 = millis();
   if(currentTime1 >= (loopTime1 + 30)&& i >=(shagov - 100)){
    times = times + 1;
    if(times >= 20) times = 20;
            loopTime1 = currentTime1;
    }}
  digitalWrite(stepPin2, LOW);           // не подаём питание на след обмотку
  w = w + 1;                             // записываем сделанный шаг
     }
         uView.setFontType(0);   //шрифт
  uView.setCursor(16, 8);  // перемещаем курсор
   uView.print("      "); // печатаем строку
  uView.display();  // отображаем содержимое из буфера экрана 
    uView.setFontType(0);   //шрифт
  uView.setCursor(16, 8);  // перемещаем курсор
   uView.print(q); // печатаем строку
  uView.display();  // отображаем содержимое из буфера экрана
    uView.setCursor(16, 26);  // перемещаем курсор
   uView.print("      "); // печатаем строку
  uView.display();  // отображаем содержимое из буфера экрана 
      uView.setFontType(0);   //шрифт
  uView.setCursor(16, 26);  // перемещаем курсор
   uView.print(w); // печатаем строку
  uView.display();  // отображаем содержимое из буфера экрана
  }  
        if(clic5 && d2 < w) {            // если клик, и нужное кол-во шагов меньше сделанного, то:
          times = 20;                    // задержка шага в начале
  shagov = w - d2;                       // из сделанного кол-ва шагов вычитаем нужное кол-во шагов
     for( long i = 0; i < shagov; ++i) {  // счётчик шагов
  digitalWrite(enablePin2, HIGH);        // Подаём питание на двигатель
  digitalWrite(directionPin2, LOW);      // Задаём направление вращения вправо
  digitalWrite(stepPin2, HIGH);          // подаётся питпние на след обмотку
  delay(times);                          // ждём
  
                  // для ускорения
    if(shagov <= 300) times = 20;
   else {
    currentTime1 = millis();
  if(currentTime1 >= (loopTime1 + 30)&& i > 0 && i < 100){
    times = times - 1;
    if(times <= 1)times = 1;
        loopTime1 = currentTime1;
    }
        currentTime1 = millis();
   if(currentTime1 >= (loopTime1 + 30)&& i >=(shagov - 100)){
    times = times + 1;
    if(times >= 20) times = 20;
            loopTime1 = currentTime1;
    }}
  digitalWrite(stepPin2, LOW);           // не подаём питание на след обмотку
  w = w - 1;                             // вычитаем один шаг
    }
        uView.setFontType(0);   //шрифт
  uView.setCursor(16, 8);  // перемещаем курсор
   uView.print("      "); // печатаем строку
  uView.display();  // отображаем содержимое из буфера экрана 
    uView.setFontType(0);   //шрифт
  uView.setCursor(16, 8);  // перемещаем курсор
   uView.print(q); // печатаем строку
  uView.display();  // отображаем содержимое из буфера экрана
    uView.setCursor(16, 26);  // перемещаем курсор
   uView.print("      "); // печатаем строку
  uView.display();  // отображаем содержимое из буфера экрана 
      uView.setFontType(0);   //шрифт
  uView.setCursor(16, 26);  // перемещаем курсор
   uView.print(w); // печатаем строку
  uView.display();  // отображаем содержимое из буфера экрана
  }  
  q1 = (h * 60) + m;                     // количество минут, на которое надо повернуть ось RA
  d = map(q1, 0, 1440, 0, 86165);        // превращаем минуты в шаги (ось RA). 86165 шагов за сутки.Можно менять в зав-ти от редуктора
  w1 = (dec * 60) + dec2;                // количество минут, на которое надо повернуть ось DEC
  d2 = map(w1, 0, 5400, 0, 81000);      // преврвшаем минуты в шаги (ось DEC) 81000 шагов.Можно менять в зав-ти от редуктора

     if(clic6){         //кнопка запуска и остановки слежения
  delay(10);            // давим дребезг кнопки
     if(clic6){
  tr = tr + 1;           // счетчик нажатий
     if (tr >= 3){
  tr = 0;                          //если tr=0 то слежение останавливается
  delay(500);
  digitalWrite(enablePin, LOW); 
  digitalWrite(stepPin, LOW);
      }
    }
  }
     if(tr == 1){                       //если tr=1 то запускается слежение  
  digitalWrite(enablePin, HIGH);         // Подаём питание на двигатель
  digitalWrite(directionPin, HIGH);      // Задаём направление вращения вправо
  digitalWrite(stepPin, HIGH);           // делаем шаг
  digitalWrite(stepPin, LOW);           // делаем шаг
  delay(1000);    // ждём
    uView.setFontType(0);   //шрифт
  uView.setCursor(0, 40);  // перемещаем курсор
  uView.print(time); // печатаем строку
  uView.display();  // отображаем содержимое из буфера экрана
    }
if(tr == 0) {
    currentTime = millis();                         // считываем время, прошедшее с момента запуска программы
  if(currentTime >= (loopTime + 1000)){              // сравниваем текущий таймер с переменной loopTime + 1 секунда
     q = q - 1;                                // включаем/выключаем LED
    loopTime = currentTime;                  // в loopTime записываем новое значение
     uView.setFontType(0);                    //шрифт
  uView.setCursor(16, 8);                    // перемещаем курсор
   uView.print(q);                            // печатаем строку
  uView.display();                               // отображаем содержимое из буфера экрана
      }
    }
  }





  










     

